commit be252334bd5e33e7ecc532254de8f48e2f67b483
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Tue Dec 12 10:43:54 2017 +0100

    ref #7095 package restructuring

diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CategoricalDataCellEditor.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CategoricalDataCellEditor.java
deleted file mode 100644
index d55868af2..000000000
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CategoricalDataCellEditor.java
+++ /dev/null
@@ -1,44 +0,0 @@
-/**
-* Copyright (C) 2017 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-package eu.etaxonomy.taxeditor.editor.workingSet.matrix;
-
-import java.util.List;
-
-import org.eclipse.nebula.widgets.nattable.edit.editor.IComboBoxDataProvider;
-import org.eclipse.nebula.widgets.nattable.filterrow.combobox.FilterRowComboBoxCellEditor;
-
-import eu.etaxonomy.cdm.model.description.CategoricalData;
-import eu.etaxonomy.cdm.model.description.State;
-
-/**
- * @author pplitzner
- * @since Dec 7, 2017
- *
- */
-public class CategoricalDataCellEditor extends FilterRowComboBoxCellEditor{
-
-    public CategoricalDataCellEditor(IComboBoxDataProvider dataProvider, int maxVisibleItems) {
-        super(dataProvider, maxVisibleItems);
-    }
-
-    @Override
-    public void setCanonicalValue(Object canonicalValue) {
-        if (canonicalValue instanceof CategoricalData) {
-            CategoricalData data = (CategoricalData)canonicalValue;
-            List<State> states = data.getStatesOnly();
-            String[] result = new String[states.size()];
-            for (int i = 0; i < states.size(); i++) {
-                result[i] = (String) this.displayConverter.canonicalToDisplayValue(
-                        this.layerCell, this.configRegistry, states.get(i));
-            }
-            setEditorValue(result);
-        }
-    }
-
-}
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CategoricalDataDisplayConverter.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CategoricalDataDisplayConverter.java
deleted file mode 100644
index b4ead7231..000000000
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CategoricalDataDisplayConverter.java
+++ /dev/null
@@ -1,46 +0,0 @@
-/**
-* Copyright (C) 2017 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-package eu.etaxonomy.taxeditor.editor.workingSet.matrix;
-
-import org.eclipse.nebula.widgets.nattable.data.convert.DisplayConverter;
-
-import eu.etaxonomy.cdm.model.description.CategoricalData;
-import eu.etaxonomy.cdm.model.description.State;
-import eu.etaxonomy.taxeditor.model.DescriptionHelper;
-
-/**
- * @author pplitzner
- * @since Dec 1, 2017
- *
- */
-public class CategoricalDataDisplayConverter extends DisplayConverter {
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public Object canonicalToDisplayValue(Object canonicalValue) {
-        if(canonicalValue instanceof CategoricalData){
-            return DescriptionHelper.getLabel(canonicalValue);
-        }
-        else if(canonicalValue instanceof State){
-            return ((State) canonicalValue).getLabel();
-        }
-        return canonicalValue.toString();
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public Object displayToCanonicalValue(Object displayValue) {
-        return null;
-    }
-
-}
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CharacterMatrix.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CharacterMatrix.java
index 50f235ee4..39deabdd3 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CharacterMatrix.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/CharacterMatrix.java
@@ -82,6 +82,10 @@ import eu.etaxonomy.cdm.model.description.SpecimenDescription;
 import eu.etaxonomy.cdm.model.description.State;
 import eu.etaxonomy.cdm.model.description.WorkingSet;
 import eu.etaxonomy.cdm.persistence.hibernate.CdmDataChangeMap;
+import eu.etaxonomy.taxeditor.editor.workingSet.matrix.categorical.CategoricalDataCellEditor;
+import eu.etaxonomy.taxeditor.editor.workingSet.matrix.categorical.CategoricalDataDisplayConverter;
+import eu.etaxonomy.taxeditor.editor.workingSet.matrix.quantitative.QuantitativeDataCellEditor;
+import eu.etaxonomy.taxeditor.editor.workingSet.matrix.quantitative.QuantitativeDataDisplayConverter;
 import eu.etaxonomy.taxeditor.model.IDirtyMarkable;
 import eu.etaxonomy.taxeditor.model.IPartContentHasDetails;
 import eu.etaxonomy.taxeditor.store.CdmStore;
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/QuantitativeDataCellEditor.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/QuantitativeDataCellEditor.java
deleted file mode 100644
index 4f3e76978..000000000
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/QuantitativeDataCellEditor.java
+++ /dev/null
@@ -1,73 +0,0 @@
-/**
-* Copyright (C) 2017 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-package eu.etaxonomy.taxeditor.editor.workingSet.matrix;
-
-import org.eclipse.nebula.widgets.nattable.edit.editor.AbstractCellEditor;
-import org.eclipse.swt.SWT;
-import org.eclipse.swt.widgets.Composite;
-import org.eclipse.swt.widgets.Control;
-
-import eu.etaxonomy.cdm.model.description.CategoricalData;
-import eu.etaxonomy.taxeditor.editor.workingSet.matrix.quantitative.QuantitativeDataComposite;
-
-/**
- * @author pplitzner
- * @since Dec 7, 2017
- *
- */
-public class QuantitativeDataCellEditor extends AbstractCellEditor{
-
-    private QuantitativeDataComposite editorControl;
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public Object getEditorValue() {
-        System.out.println("getValue");
-        return editorControl.getMin()+" "+editorControl.getAvg()+" "+editorControl.getMax();
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public void setEditorValue(Object value) {
-        if(value instanceof CategoricalData){
-            System.out.println("setValue: "+value);
-        }
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public Control getEditorControl() {
-        return editorControl;
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public Control createEditorControl(Composite parent) {
-        return new QuantitativeDataComposite(parent, SWT.NONE);
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    protected Control activateCell(Composite parent, Object originalCanonicalValue) {
-        this.editorControl = (QuantitativeDataComposite) createEditorControl(parent);
-        return editorControl;
-    }
-
-
-}
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/QuantitativeDataDisplayConverter.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/QuantitativeDataDisplayConverter.java
deleted file mode 100644
index b41f53d2d..000000000
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/QuantitativeDataDisplayConverter.java
+++ /dev/null
@@ -1,42 +0,0 @@
-/**
-* Copyright (C) 2017 EDIT
-* European Distributed Institute of Taxonomy
-* http://www.e-taxonomy.eu
-*
-* The contents of this file are subject to the Mozilla Public License Version 1.1
-* See LICENSE.TXT at the top of this package for the full license terms.
-*/
-package eu.etaxonomy.taxeditor.editor.workingSet.matrix;
-
-import org.eclipse.nebula.widgets.nattable.data.convert.DisplayConverter;
-
-import eu.etaxonomy.cdm.model.description.QuantitativeData;
-import eu.etaxonomy.taxeditor.model.DescriptionHelper;
-
-/**
- * @author pplitzner
- * @since Dec 1, 2017
- *
- */
-public class QuantitativeDataDisplayConverter extends DisplayConverter {
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public Object canonicalToDisplayValue(Object canonicalValue) {
-        if(canonicalValue instanceof QuantitativeData){
-            return DescriptionHelper.getLabel(canonicalValue);
-        }
-        return canonicalValue.toString();
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    @Override
-    public Object displayToCanonicalValue(Object displayValue) {
-        return null;
-    }
-
-}
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/categorical/CategoricalDataCellEditor.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/categorical/CategoricalDataCellEditor.java
new file mode 100644
index 000000000..d42521057
--- /dev/null
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/categorical/CategoricalDataCellEditor.java
@@ -0,0 +1,44 @@
+/**
+* Copyright (C) 2017 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.taxeditor.editor.workingSet.matrix.categorical;
+
+import java.util.List;
+
+import org.eclipse.nebula.widgets.nattable.edit.editor.IComboBoxDataProvider;
+import org.eclipse.nebula.widgets.nattable.filterrow.combobox.FilterRowComboBoxCellEditor;
+
+import eu.etaxonomy.cdm.model.description.CategoricalData;
+import eu.etaxonomy.cdm.model.description.State;
+
+/**
+ * @author pplitzner
+ * @since Dec 7, 2017
+ *
+ */
+public class CategoricalDataCellEditor extends FilterRowComboBoxCellEditor{
+
+    public CategoricalDataCellEditor(IComboBoxDataProvider dataProvider, int maxVisibleItems) {
+        super(dataProvider, maxVisibleItems);
+    }
+
+    @Override
+    public void setCanonicalValue(Object canonicalValue) {
+        if (canonicalValue instanceof CategoricalData) {
+            CategoricalData data = (CategoricalData)canonicalValue;
+            List<State> states = data.getStatesOnly();
+            String[] result = new String[states.size()];
+            for (int i = 0; i < states.size(); i++) {
+                result[i] = (String) this.displayConverter.canonicalToDisplayValue(
+                        this.layerCell, this.configRegistry, states.get(i));
+            }
+            setEditorValue(result);
+        }
+    }
+
+}
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/categorical/CategoricalDataDisplayConverter.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/categorical/CategoricalDataDisplayConverter.java
new file mode 100644
index 000000000..cf7de7180
--- /dev/null
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/categorical/CategoricalDataDisplayConverter.java
@@ -0,0 +1,46 @@
+/**
+* Copyright (C) 2017 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.taxeditor.editor.workingSet.matrix.categorical;
+
+import org.eclipse.nebula.widgets.nattable.data.convert.DisplayConverter;
+
+import eu.etaxonomy.cdm.model.description.CategoricalData;
+import eu.etaxonomy.cdm.model.description.State;
+import eu.etaxonomy.taxeditor.model.DescriptionHelper;
+
+/**
+ * @author pplitzner
+ * @since Dec 1, 2017
+ *
+ */
+public class CategoricalDataDisplayConverter extends DisplayConverter {
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public Object canonicalToDisplayValue(Object canonicalValue) {
+        if(canonicalValue instanceof CategoricalData){
+            return DescriptionHelper.getLabel(canonicalValue);
+        }
+        else if(canonicalValue instanceof State){
+            return ((State) canonicalValue).getLabel();
+        }
+        return canonicalValue.toString();
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public Object displayToCanonicalValue(Object displayValue) {
+        return null;
+    }
+
+}
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/quantitative/QuantitativeDataCellEditor.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/quantitative/QuantitativeDataCellEditor.java
new file mode 100644
index 000000000..b51beb9b4
--- /dev/null
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/quantitative/QuantitativeDataCellEditor.java
@@ -0,0 +1,72 @@
+/**
+* Copyright (C) 2017 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.taxeditor.editor.workingSet.matrix.quantitative;
+
+import org.eclipse.nebula.widgets.nattable.edit.editor.AbstractCellEditor;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+
+import eu.etaxonomy.cdm.model.description.CategoricalData;
+
+/**
+ * @author pplitzner
+ * @since Dec 7, 2017
+ *
+ */
+public class QuantitativeDataCellEditor extends AbstractCellEditor{
+
+    private QuantitativeDataComposite editorControl;
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public Object getEditorValue() {
+        System.out.println("getValue");
+        return editorControl.getMin()+" "+editorControl.getAvg()+" "+editorControl.getMax();
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public void setEditorValue(Object value) {
+        if(value instanceof CategoricalData){
+            System.out.println("setValue: "+value);
+        }
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public Control getEditorControl() {
+        return editorControl;
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public Control createEditorControl(Composite parent) {
+        return new QuantitativeDataComposite(parent, SWT.NONE);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    protected Control activateCell(Composite parent, Object originalCanonicalValue) {
+        this.editorControl = (QuantitativeDataComposite) createEditorControl(parent);
+        return editorControl;
+    }
+
+
+}
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/quantitative/QuantitativeDataDisplayConverter.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/quantitative/QuantitativeDataDisplayConverter.java
new file mode 100644
index 000000000..01bea4ad3
--- /dev/null
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/workingSet/matrix/quantitative/QuantitativeDataDisplayConverter.java
@@ -0,0 +1,42 @@
+/**
+* Copyright (C) 2017 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.taxeditor.editor.workingSet.matrix.quantitative;
+
+import org.eclipse.nebula.widgets.nattable.data.convert.DisplayConverter;
+
+import eu.etaxonomy.cdm.model.description.QuantitativeData;
+import eu.etaxonomy.taxeditor.model.DescriptionHelper;
+
+/**
+ * @author pplitzner
+ * @since Dec 1, 2017
+ *
+ */
+public class QuantitativeDataDisplayConverter extends DisplayConverter {
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public Object canonicalToDisplayValue(Object canonicalValue) {
+        if(canonicalValue instanceof QuantitativeData){
+            return DescriptionHelper.getLabel(canonicalValue);
+        }
+        return canonicalValue.toString();
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    @Override
+    public Object displayToCanonicalValue(Object displayValue) {
+        return null;
+    }
+
+}